;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>Text Writing Program by Iambian Zenith <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
;Very basic notes: This program destroys registers A,BC,DE,and HL.
; The program also alters or destroys (penRow), (penCol), and will alter the
; flags pertaining to the displaying of text. Destroys Op3, as well.

;This program is designed to draw text onto the buffer using box coordinates found in "tBoxDat1.asm" and passed
;in as arguments to this program. Relies on some romcalls, so don't alter register IY before running this subroutine.
;Arguments:
;	DE= Boxcoords (this routine will do DE+2 to space text from box edge)
;	HL= Pointer to text string
;	BC= Pointer to the data table
;       A = Shade on this line 0=First row
;Notes: The program will take certain instructions in the text.
;01=Make next set of letters reverse video
;02=Make next set of letters normal video
;03=Set reset line below
;04=Don't clear line below
;06=Go down one line (6 pixels, normal stuff)
;07=Go down one line (7 pixels, more for spacing)
;Note for the going down part. When you go down, the column portion is reset to boxcoordinate specifications.
;
;Any number equal to or past 90 will be treated differently.
; It will jump to another part of the program, which all the numbers between $90 and $FD are treated as tokens.
; This is defined by a table that is preset in the saveSScreen buffer. 90=buffer+0 : FE=buffer+(unitsize*($FE-$90))
; For table values, just add by $90 to get the correct portion... The program automatically calculates the offset,
; provided that you put it in the program - otherwise the default is 9 bytes.
;FE=Next number is the table unit size. The tokens are this long... syntax: "$FE,$06", six bytes long.
;FF=To end the call to this program.
;
;Flags:
; textInverse,(IY+textFlags) = 1 for reverse video  \ textEraseBelow,(IY+textFlags) = 1 to erase line below character
; textWrite,(IY+sGrFlags) = 1 to write to graph buffer instead of display
;Write coordinates to (penCol) and (penRow). Load register PAIR to (penCol), with LSB=L=(penCol)

;#include "ti83plus.inc"
;.org userMem-2
;.db $BB,$6D

pointcoordinates	equ	Op3+0
textpointer		equ	Op3+2
datatablestart		equ	Op3+4
tableUnitSize		equ	Op3+6
userShading		equ	Op3+7
shadeCounter		equ	Op3+8

DrawFormattedText:
 ld (userShading),a \ set textWrite,(IY+sGrFlags) \ res textInverse,(IY+textFlags) \ res textEraseBelow,(IY+textFlags)
 or a \ jr nz,DT_skipReturn \ set textInverse,(IY+textFlags)
DT_skipReturn: xor a \ ld (shadeCounter),a \ ld (datatablestart),bc \ ex de,hl
 ld bc,$0202 ;two rows down and 2 cols across. (64 rows, 96 cols)
 add hl,bc \ ld (pointcoordinates),hl \ ld (textpointer),de \ ld (penCol),hl \ ld a,9 \ ld (tableUnitSize),a
DT_TextLoopMain:  ld bc,(pointCoordinates) \ ld hl,(textpointer)
DT_TextLoopSub: ld a,(hl) \ inc hl
 cp 1    \ jr z,DT_ReverseVideo	\ cp 2    \ jr z,DT_NormalVideo
 cp 3    \ jr z,DT_EraseBelow	\ cp 4    \ jr z,DT_DontEraseBelow
 cp 6    \ jr z,DT_GoDown	\ cp 7    \ jr z,DT_GoDown
 cp $FF  \ ret z		\ cp $90  \ jp nc,DT_AboveTextLimit
 bcall(_VPutMap) \ jr DT_TextLoopSub
DT_ReverseVideo:   set textInverse,(IY+textFlags)    \ jr DT_TextLoopSub
DT_NormalVideo:    res textInverse,(IY+textFlags)    \ jr DT_TextLoopSub
DT_EraseBelow:     set textEraseBelow,(IY+textFlags) \ jr DT_TextLoopSub
DT_DontEraseBelow: res textEraseBelow,(IY+textFlags) \ jr DT_TextLoopSub
DT_GoDown: push hl \ dec hl \ ld bc,(penCol) \ ld a,b \ add a,(hl) \ ld b,a \ ld a,(pointCoordinates) \ ld c,a \ ld (penCol),bc \ ld hl,shadeCounter
 inc (hl) \ ld b,(hl) \ ld a,(userShading) \ pop hl \ cp b \ jr nz,DT_NormalVideo \ jr DT_reverseVideo
DT_AboveTextLimit: cp $FF  \ ret z \ cp $FE  \ jr z,setNewUnitSize \ sub $90
 push hl \ ld h,a \ ld a,(tableUnitSize) \ ld e,a
MUL_H_by_E: \ ld d,0 \ ld l,d \ ld b,8
MUL_loop: add hl,hl \ jp nc,MUL_skip \ add hl,de
MUL_skip: djnz MUL_loop \ ld de,(datatablestart) \ add hl,de \ ld b,a \ bcall(_VPutSN) \ pop hl \ jp DT_TextLoopSub
setNewUnitSize:  ld a,(hl) \ inc hl \ ld (tableUnitSize),a \ jp DT_TextLoopSub
.end